<?php
/**
 *        Ingame Scenes - by Amaryllion © 2015
 *
 *        This program is free software: you can redistribute it and/or modify
 *        it under the terms of the GNU General Public License as published by
 *        the Free Software Foundation, either version 3 of the License, or
 *        (at your option) any later version.
 *
 *        This program is distributed in the hope that it will be useful,
 *        but WITHOUT ANY WARRANTY; without even the implied warranty of
 *        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *        GNU General Public License for more details.
 *
 *        You should have received a copy of the GNU General Public License
 *        along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

if(!defined("IN_MYBB"))
{
    die("This file cannot be accessed directly.");
}

 //error_reporting ( -1 );
 //ini_set ( 'display_errors', true ); 


$plugins->add_hook('usercp_profile_start', 'prepare_awaystartdate');
//$plugins->add_hook("global_end", "add_css");
$plugins->add_hook("usercp_profile_end", "show_awaystartdate");
$plugins->add_hook("usercp_do_profile_end", "save_awaystartdate");



// Templates: usercp_profile

function awaystartdate_info()
{
    global $mybb, $db, $plugins_cache;
    
    
    $plugininfo = array(
                "name"			 	 =>        "Away Start Date",
		        "description"		 =>         "Ermöglicht das Festlegen eines Anfangsdatum für die Abwesenheit.",
                "website"            =>        "",
                "author"             =>        "Amaryllion",
                "authorsite"         =>        "",
                "version"            =>        "1.0",
                "guid"               =>        "",
                "compatibility"      =>        "18*",
        );
    
	return $plugininfo;
}

/*
function awaystartdate_install()
{
    
}

function awaystartdate_is_installed()
{
    
}

function awaystartdate_uninstall()
{
    
}
*/

function awaystartdate_activate()
{
    global $db;

    require MYBB_ROOT."/inc/adminfunctions_templates.php";
    
    $template_part = get_templatepart();
    $find_part = get_findtemplatepart();
    $replacement_part = get_replacementtemplatepart();
    
    // anhängen
    find_replace_templatesets("usercp_profile_away", "#".preg_quote($find_part)."#i", $template_part.$replacement_part);
    
    
}

function awaystartdate_deactivate()
{
    global $db;

    require MYBB_ROOT."/inc/adminfunctions_templates.php";
    
    $template_part = get_templatepart();
    $find_part = get_findtemplatepart();
    $replacement_part = get_replacementtemplatepart();

    find_replace_templatesets("usercp_profile_away", "#".preg_quote($template_part.$replacement_part)."#i", $find_part, 0);
    
}

function get_templatepart()
{
    $template_part = '<td colspan="3"><span class="smalltext">{$lang->awaystart_date}</span></td></tr><tr><td><select name="startawayday"><option value="">&nbsp;</option>{$startawaydatesel}</select></td><td><select name="startawaymonth"><option value="">&nbsp;</option><option value="1" {$startawaydatemonthsel[\'1\']}>{$lang->month_1}</option><option value="2" {$startawaydatemonthsel[\'2\']}>{$lang->month_2}</option><option value="3" {$startawaydatemonthsel[\'3\']}>{$lang->month_3}</option><option value="4" {$startawaydatemonthsel[\'4\']}>{$lang->month_4}</option><option value="5" {$startawaydatemonthsel[\'5\']}>{$lang->month_5}</option><option value="6" {$startawaydatemonthsel[\'6\']}>{$lang->month_6}</option><option value="7" {$startawaydatemonthsel[\'7\']}>{$lang->month_7}</option><option value="8" {$startawaydatemonthsel[\'8\']}>{$lang->month_8}</option><option value="9" {$startawaydatemonthsel[\'9\']}>{$lang->month_9}</option><option value="10" {$startawaydatemonthsel[\'10\']}>{$lang->month_10}</option><option value="11" {$startawaydatemonthsel[\'11\']}>{$lang->month_11}</option><option value="12" {$startawaydatemonthsel[\'12\']}>{$lang->month_12}</option></select></td><td><input type="text" class="textbox" size="4" maxlength="4" name="startawayyear" value="{$startawaydate[\'2\']}" /></td>';
    
    return $template_part;
}

function get_findtemplatepart()
{
    $find_part = '<td colspan="3"><span class="smalltext">{$lang->return_date}</span></td>';
    
    return $find_part;
}

function get_replacementtemplatepart()
{
    $find_part = get_findtemplatepart();
    $replacement_part = "<tr>".$find_part."</tr>";
    
    return $replacement_part;
}


function prepare_awaystartdate()
{
    global $mybb, $lang, $templates, $errors, $teststring, $startawaydatesel, $startawaydatemonthsel, $startawaydate, $awaydate, $teststring;
    
    $lang->load("awaystartdate");
    
    if($mybb->settings['allowaway'] != 0)
	{
        
		if($errors)
		{
			$formatteddate = "errors";
			$startawaydate = array();
			$startawaydate[0] = $mybb->get_input('startawayday', MyBB::INPUT_INT);
			$startawaydate[1] = $mybb->get_input('startawaymonth', MyBB::INPUT_INT);
			$startawaydate[2] = $mybb->get_input('startawayyear', MyBB::INPUT_INT);
		}
		else
		{
			$formatteddate = "";

            if($mybb->user['awaydate'] !=0) {
                $formatteddate = date('d-n-Y', $mybb->user['awaydate']);
            }
            //$teststring = $formatteddate;
            
            $startawaydate = explode("-", $formatteddate);
            
			if(!isset($startawaydate[1]))
			{
				$startawaydate[1] = 0;
			}
			if(!isset($startawaydate[2]))
			{
				$startawaydate[2] = '';
			}
            
            
		}
        
        $startawaydatesel = '';
        for($day = 1; $day <= 31; ++$day)
        {
            if($startawaydate[0] == $day)
            {
                $selected = "selected=\"selected\"";
            }
            else
            {
                $selected = '';
            }

            eval("\$startawaydatesel .= \"".$templates->get("usercp_profile_day")."\";");
        }

        $startawaydatemonthsel = array();
        foreach(range(1, 12) as $month)
        {
            $startawaydatemonthsel[$month] = '';
        }
        
        $startawaydatemonthsel[$startawaydate[1]] = "selected";
        $teststring = $startawaydate[1];
    }
}



function show_awaystartdate()
{

    
}





// Save startdate if away in User CP profile settings
function save_awaystartdate()
{
	global $mybb, $lang, $user, $awaydate, $cache;
    
    if($mybb->get_input('away', MyBB::INPUT_INT) == 1 && $mybb->settings['allowaway'] != 0 && !empty($mybb->input['startawayday']))
	{
		$awaydate = TIME_NOW;
		
        
        if(!empty($mybb->input['startawayday']))
		{
			// If the user has indicated that they will return on a specific day, but not month or year, assume it is current month and year
			if(!$mybb->get_input('startawaymonth', MyBB::INPUT_INT))
			{
				$mybb->input['startawaymonth'] = my_date('n', $awaydate);
			}
			if(!$mybb->get_input('startawayyear', MyBB::INPUT_INT))
			{
				$mybb->input['startawayyear'] = my_date('Y', $awaydate);
			}

			$start_month = (int)substr($mybb->get_input('startawaymonth'), 0, 2);
			$start_day = (int)substr($mybb->get_input('startawayday'), 0, 2);
			$start_year = min((int)$mybb->get_input('startawayyear'), 9999);
            
            //valid date?
            if (checkdate($start_month,$start_day,$start_year) == true) {
                $awaydate = gmmktime(0, 0, 0, $start_month, $start_day, $start_year);
            } 
		}
		
        if(!empty($mybb->input['awayday']))
		{
			// If the user has indicated that they will return on a specific day, but not month or year, assume it is current month and year
			if(!$mybb->get_input('awaymonth', MyBB::INPUT_INT))
			{
				$mybb->input['awaymonth'] = my_date('n', $awaydate);
			}
			if(!$mybb->get_input('awayyear', MyBB::INPUT_INT))
			{
				$mybb->input['awayyear'] = my_date('Y', $awaydate);
			}

			$return_month = (int)substr($mybb->get_input('awaymonth'), 0, 2);
			$return_day = (int)substr($mybb->get_input('awayday'), 0, 2);
			$return_year = min((int)$mybb->get_input('awayyear'), 9999);

			// Check if return date is after the away date.
			$returntimestamp = gmmktime(0, 0, 0, $return_month, $return_day, $return_year);
			$awaytimestamp = gmmktime(0, 0, 0, my_date('n', $awaydate), my_date('j', $awaydate), my_date('Y', $awaydate));
			if($return_year < my_date('Y', $awaydate) || ($returntimestamp < $awaytimestamp && $return_year == my_date('Y', $awaydate)))
			{
				error($lang->error_usercp_return_date_past);
			}

			$returndate = "{$return_day}-{$return_month}-{$return_year}";
		}
		else
		{
			$returndate = "";
		}
        
        
        /*
		$away = array(
			"away" => 1,
			"date" => $awaydate,
			"returndate" => $returndate,
			"awayreason" => $mybb->get_input('awayreason')
		);
        */
        
            
        require_once "inc/datahandlers/user.php";
        $userhandler = new UserDataHandler("update");


        /*
        $user = array(
            "uid" => $mybb->user['uid']
        );
        */
        
        $user['away'] = array(
			"away" => 1,
			"date" => $awaydate,
			"returndate" => $returndate,
			"awayreason" => $mybb->get_input('awayreason')
		);
        
        $userhandler->set_data($user);
        
        if(!$userhandler->validate_user())
        {
            $errors = $userhandler->get_friendly_errors();
            $errors = inline_error($errors);
            
        }
        else
        {
            $userhandler->update_user();

        }
        
        
        // AccountSwitcher?
        
        $plugins_cache = $cache->read('plugins');
        if (is_array($plugins_cache) && is_array($plugins_cache['active']) && $plugins_cache['active']['accountswitcher'])
        {
            require_once MYBB_ROOT."inc/plugins/accountswitcher/as_usercp.php";
            accountswitcher_set_away();
        }
        
        
        
        
	}
	
    
    
}

/*
function add_css()
{
	global $mybb, $headerinclude;

	// Add css to headerinclude
	if ($mybb->settings['minifycss'] == 1)
	{ // Minified css
		$headerinclude .= '
		<link type="text/css" rel="stylesheet" href="'.$mybb->asset_url.'/jscripts/awaystartdate/awaystartdate.min.css" />
		';
	}
	else 
	{
		$headerinclude .= '
		<link type="text/css" rel="stylesheet" href="'.$mybb->asset_url.'/jscripts/awaystartdate/awaystartdate.css" />
		';
	}
}
*/

?>